Subject: Re: [iproute2 patch]: Add 'ip tuntap' facility for managing tun/tap devices

From: Stephen Hemminger <[email-masked]>
Date: Wed, 27 May 2009 10:06:47 -0700

On Wed, 27 May 2009 17:49:32 +0100
David Woodhouse <[email-masked]> wrote:

> On Wed, 2009-05-27 at 09:38 -0700, Stephen Hemminger wrote:
> > On Wed, 27 May 2009 17:32:17 +0100
> > David Woodhouse <[email-masked]> wrote:
> > 
> > > On Mon, 2009-05-04 at 15:49 +0100, David Woodhouse wrote:
> > > > On Mon, 2009-05-04 at 07:38 -0700, Stephen Hemminger wrote:
> > > > > I would rather provide a netlink for managing TUNTAP interfaces
> > > > 
> > > > I'm not sure that makes a lot of sense. We'd be adding a new, duplicate
> > > > user API solely for the benefit of iproute2; it's not as if we'd ever be
> > > > able to get rid of the existing interface that everyone uses.
> > > >
> > > > Unless you want to ditch the /dev/net/tun chardev completely and do
> > > > _everything_ over netlink, maybe... but that doesn't seem particularly
> > > > worthwhile either.
> > > > 
> > > > >  and reorganize under ip link??
> > > > 
> > > > It seemed more intuitive to model it after 'ip tunnel'. How would you
> > > > want it to look?
> > > 
> > > Ping?
> > > 
> > 
> > Almost all of iproute2 is based on netlink, I don't want to add non netlink
> > interfaces. 
> 
> So you want to add a new interface to the kernel which duplicates the
> one we've had for years, then make userspace which will only work with
> newer kernels?

Well if the kernel interface existed for years, there were obviously other
tools using it. Why do you have to cram that into iproute2?

--